Subject: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

From: Stefan Monnier <[email-masked]>
Date: Sat, 25 Jul 2020 18:27:13 -0400

>> > There are also some functions declared 'pure' that appear to have side
>> > effects: kbd, package-get-version
>>
>> Which side-effects are you thinking of?
>>
>
> I wouldn't know about side effects, but `kbd' is definitely not pure
> by the "homomorphism w.r.t. eql" definition as it takes a string
> argument.

Taking string arguments is not a problem (`eql` strings are also
`equal`).  It's returning a fresh new string/vector that is a problem
(which also affects `kbd`, indeed).

        Stefan